Public Member Functions

# OGRGeometry Class Reference

`#include <ogr_geometry.h>`

Inheritance diagram for OGRGeometry:

List of all members.

## Public Member Functions
virtual int | getDimension () const =0
| Get the dimension of this object.
virtual int | getCoordinateDimension () const
| Get the dimension of the coordinates in this object.
virtual OGRBoolean | IsEmpty () const =0
| Returns TRUE (non-zero) if the object has no points.
virtual OGRBoolean | IsValid () const
| Test if the geometry is valid.
virtual OGRBoolean | IsSimple () const
| Test if the geometry is simple.
virtual OGRBoolean | IsRing () const
| Test if the geometry is a ring.
virtual void | empty ()=0
| Clear geometry information. This restores the geometry to it's initial state after construction, and before assignment of actual geometry.
virtual OGRGeometry * | clone () const =0
| Make a copy of this object.
virtual void | getEnvelope (OGREnvelope *psEnvelope) const =0
| Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure.
virtual void | getEnvelope (OGREnvelope3D *psEnvelope) const =0
| Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure.
virtual int | WkbSize () const =0
| Returns size of related binary representation.
virtual OGRErr | importFromWkb (unsigned char *, int=-1)=0
| Assign geometry from well known binary data.
virtual OGRErr | exportToWkb (OGRwkbByteOrder, unsigned char *, OGRwkbVariant=wkbVariantOgc) const =0
| Convert a geometry into well known binary format.
virtual OGRErr | importFromWkt (char **ppszInput)=0
| Assign geometry from well known text data.
virtual OGRErr | exportToWkt (char **ppszDstText) const =0
| Convert a geometry into well known text format.
virtual OGRwkbGeometryType | getGeometryType () const =0
| Fetch geometry type.
virtual const char * | getGeometryName () const =0
| Fetch WKT name for geometry type.
virtual void | dumpReadable (FILE *, const char *=NULL, char **papszOptions=NULL) const
| Dump geometry in well known text format to indicated output file.
virtual void | flattenTo2D ()=0
| Convert geometry to strictly 2D. In a sense this converts all Z coordinates to 0.0.
virtual char * | exportToGML (const char *const *papszOptions=NULL) const
| Convert a geometry into GML format.
virtual char * | exportToKML () const
| Convert a geometry into KML format.
virtual char * | exportToJson () const
| Convert a geometry into GeoJSON format.
virtual void | closeRings ()
| Force rings to be closed.
virtual void | setCoordinateDimension (int nDimension)
| Set the coordinate dimension.
void | assignSpatialReference (OGRSpatialReference *poSR)
| Assign spatial reference to this object.
OGRSpatialReference * | getSpatialReference (void) const
| Returns spatial reference system for object.
virtual OGRErr | transform (OGRCoordinateTransformation *poCT)=0
| Apply arbitrary coordinate transformation to geometry.
OGRErr | transformTo (OGRSpatialReference *poSR)
| Transform geometry to new spatial reference system.
virtual void | segmentize (double dfMaxLength)
| Modify the geometry such it has no segment longer then the given distance.
virtual OGRBoolean | Intersects (OGRGeometry *) const
| Do these features intersect?
virtual OGRBoolean | Equals (OGRGeometry *) const =0
| Returns TRUE if two geometries are equivalent.
virtual OGRBoolean | Disjoint (const OGRGeometry *) const
| Test for disjointness.
virtual OGRBoolean | Touches (const OGRGeometry *) const
| Test for touching.
virtual OGRBoolean | Crosses (const OGRGeometry *) const
| Test for crossing.
virtual OGRBoolean | Within (const OGRGeometry *) const
| Test for containment.
virtual OGRBoolean | Contains (const OGRGeometry *) const
| Test for containment.
virtual OGRBoolean | Overlaps (const OGRGeometry *) const
| Test for overlap.
virtual OGRGeometry * | Boundary () const
| Compute boundary.
virtual double | Distance (const OGRGeometry *) const
| Compute distance between two geometries.
virtual OGRGeometry * | ConvexHull () const
| Compute convex hull.
virtual OGRGeometry * | Buffer (double dfDist, int nQuadSegs=30) const
| Compute buffer of geometry.
virtual OGRGeometry * | Intersection (const OGRGeometry *) const
| Compute intersection.
virtual OGRGeometry * | Union (const OGRGeometry *) const
| Compute union.
virtual OGRGeometry * | UnionCascaded () const
| Compute union using cascading.
virtual OGRGeometry * | Difference (const OGRGeometry *) const
| Compute difference.
virtual OGRGeometry * | SymDifference (const OGRGeometry *) const
| Compute symmetric difference.
virtual OGRErr | Centroid (OGRPoint *poPoint) const
| Compute the geometry centroid.
virtual OGRGeometry * | Simplify (double dTolerance) const
| Simplify the geometry.
OGRGeometry * | SimplifyPreserveTopology (double dTolerance) const
| Simplify the geometry while preserving topology.
virtual OGRGeometry * | Polygonize () const
| Polygonizes a set of sparse edges.
virtual OGRGeometry * | SymmetricDifference (const OGRGeometry *) const CPL_WARN_DEPRECATED("Non standard method. Use SymDifference() instead")
| Compute symmetric difference (deprecated).
virtual OGRGeometry * | getBoundary () const CPL_WARN_DEPRECATED("Non standard method. Use Boundary() instead")
| Compute boundary (deprecated).
virtual void | swapXY ()
| Swap x and y coordinates.

## Detailed Description

Abstract base class for all geometry classes.

Some spatial analysis methods require that OGR is built on the GEOS library to work properly. The precise meaning of methods that describe spatial relationships between geometries is described in the SFCOM, or other simple features interface specifications, like "OpenGIS® Implementation Specification for Geographic information - Simple feature access - Part 1: Common architecture" (OGC 06-103r3)

## Member Function Documentation

void OGRGeometry::assignSpatialReference | ( | OGRSpatialReference * | poSR | ) |

Assign spatial reference to this object.

Any existing spatial reference is replaced, but under no circumstances does this result in the object being reprojected. It is just changing the interpretation of the existing geometry. Note that assigning a spatial reference increments the reference count on the OGRSpatialReference, but does not copy it.

This is similar to the SFCOM IGeometry::put_SpatialReference() method.

This method is the same as the C function OGR_G_AssignSpatialReference().

Parameters:

  | poSR | new spatial reference system to apply.

References OGRSpatialReference::Reference(), and OGRSpatialReference::Release().

Referenced by Boundary(), Buffer(), Centroid(), OGRPolygon::clone(), OGRPoint::clone(), OGRMultiPolygon::clone(), OGRMultiPoint::clone(), OGRMultiLineString::clone(), OGRLineString::clone(), OGRLinearRing::clone(), OGRGeometryCollection::clone(), ConvexHull(), OGRGeometryFactory::createFromWkb(), OGRGeometryFactory::createFromWkt(), Difference(), OGRGeometryFactory::forceToMultiLineString(), OGRGeometryFactory::forceToMultiPoint(), OGRGeometryFactory::forceToMultiPolygon(), OGRGeometryFactory::forceToPolygon(), OGRLineString::getSubLine(), Intersection(), OGR_G_PointOnSurface(), Polygonize(), Simplify(), SimplifyPreserveTopology(), SymDifference(), OGRPolygon::transform(), OGRPoint::transform(), OGRLineString::transform(), OGRGeometryCollection::transform(), Union(), and UnionCascaded().

OGRGeometry * OGRGeometry::Boundary | ( |  | ) | const`[virtual]`

Compute boundary.

A new geometry object is created and returned containing the boundary of the geometry on which the method is invoked.

This method is the same as the C function OGR_G_Boundary().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Returns:
  a newly allocated geometry now owned by the caller, or NULL on failure.

Since:
  OGR 1.8.0

References assignSpatialReference(), and getSpatialReference().

Referenced by getBoundary().

OGRGeometry * OGRGeometry::Buffer | ( | double | dfDist,
|  | int | nQuadSegs = `30` |
| ) |  |  | const`[virtual]`

Compute buffer of geometry.

Builds a new geometry containing the buffer region around the geometry on which it is invoked. The buffer is a polygon containing the region within the buffer distance of the original geometry.

Some buffer sections are properly described as curves, but are converted to approximate polygons. The nQuadSegs parameter can be used to control how many segements should be used to define a 90 degree curve - a quadrant of a circle. A value of 30 is a reasonable default. Large values result in large numbers of vertices in the resulting buffer geometry while small numbers reduce the accuracy of the result.

This method is the same as the C function OGR_G_Buffer().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters:

  | dfDist | the buffer distance to be applied. Should be expressed into the same unit as the coordinates of the geometry.
  | nQuadSegs | the number of segments used to approximate a 90 degree (quadrant) of curvature.

Returns:
  the newly created geometry, or NULL if an error occurs.

References assignSpatialReference(), and getSpatialReference().

int OGRGeometry::Centroid | ( | OGRPoint * | poPoint | ) | const`[virtual]`

Compute the geometry centroid.

The centroid location is applied to the passed in OGRPoint object. The centroid is not necessarily within the geometry.

This method relates to the SFCOM ISurface::get_Centroid() method however the current implementation based on GEOS can operate on other geometry types such as multipoint, linestring, geometrycollection such as multipolygons. OGC SF SQL 1.1 defines the operation for surfaces (polygons). SQL/MM-Part 3 defines the operation for surfaces and multisurfaces (multipolygons).

This function is the same as the C function OGR_G_Centroid().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Returns:
  OGRERR_NONE on success or OGRERR_FAILURE on error.

Since:
  OGR 1.8.0 as a OGRGeometry method (previously was restricted to OGRPolygon)

References assignSpatialReference(), OGRPoint::empty(), getGeometryType(), getSpatialReference(), OGRPoint::getX(), OGRPoint::getY(), OGRPoint::IsEmpty(), OGRPoint::setX(), OGRPoint::setY(), and wkbPoint.

Referenced by OGR_G_Centroid().

OGRGeometry * OGRGeometry::clone | ( |  | ) | const`[pure virtual]`

Make a copy of this object.

This method relates to the SFCOM IGeometry::clone() method.

This method is the same as the C function OGR_G_Clone().

Returns:
  a new object instance with the same geometry, and spatial reference system as the original.

Implemented in OGRPoint, OGRLineString, OGRLinearRing, OGRPolygon, OGRGeometryCollection, OGRMultiPolygon, OGRMultiPoint, and OGRMultiLineString.

Referenced by OGRGeometryCollection::addGeometry(), OGRLayer::Clip(), OGRLayer::Erase(), OGRLayer::GetFeature(), OGRLayer::Identity(), OGRFeature::SetGeomField(), OGRLayer::SymDifference(), OGRLayer::Union(), and OGRLayer::Update().

void OGRGeometry::closeRings | ( |  | ) | `[virtual]`

Force rings to be closed.

If this geometry, or any contained geometries has polygon rings that are not closed, they will be closed by adding the starting point at the end.

Reimplemented in OGRLinearRing, OGRPolygon, and OGRGeometryCollection.

OGRBoolean OGRGeometry::Contains | ( | const OGRGeometry * | poOtherGeom | ) | const`[virtual]`

Test for containment.

Tests if actual geometry object contains the passed geometry.

This method is the same as the C function OGR_G_Contains().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters:

  | poOtherGeom | the geometry to compare to this geometry.

Returns:
  TRUE if poOtherGeom contains this geometry, otherwise FALSE.

OGRGeometry * OGRGeometry::ConvexHull | ( |  | ) | const`[virtual]`

Compute convex hull.

A new geometry object is created and returned containing the convex hull of the geometry on which the method is invoked.

This method is the same as the C function OGR_G_ConvexHull().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Returns:
  a newly allocated geometry now owned by the caller, or NULL on failure.

References assignSpatialReference(), and getSpatialReference().

OGRBoolean OGRGeometry::Crosses | ( | const OGRGeometry * | poOtherGeom | ) | const`[virtual]`

Test for crossing.

Tests if this geometry and the other passed into the method are crossing.

This method is the same as the C function OGR_G_Crosses().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters:

  | poOtherGeom | the geometry to compare to this geometry.

Returns:
  TRUE if they are crossing, otherwise FALSE.

OGRGeometry * OGRGeometry::Difference | ( | const OGRGeometry * | poOtherGeom | ) | const`[virtual]`

Compute difference.

Generates a new geometry which is the region of this geometry with the region of the second geometry removed.

This method is the same as the C function OGR_G_Difference().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters:

  | poOtherGeom | the other geometry removed from "this" geometry.

Returns:
  a new geometry representing the difference or NULL if the difference is empty or an error occurs.

References assignSpatialReference(), getSpatialReference(), and OGRSpatialReference::IsSame().

Referenced by OGRLayer::Erase(), OGRLayer::Identity(), OGRLayer::SymDifference(), OGRLayer::Union(), and OGRLayer::Update().

OGRBoolean OGRGeometry::Disjoint | ( | const OGRGeometry * | poOtherGeom | ) | const`[virtual]`

Test for disjointness.

Tests if this geometry and the other passed into the method are disjoint.

This method is the same as the C function OGR_G_Disjoint().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters:

  | poOtherGeom | the geometry to compare to this geometry.

Returns:
  TRUE if they are disjoint, otherwise FALSE.

double OGRGeometry::Distance | ( | const OGRGeometry * | poOtherGeom | ) | const`[virtual]`

Compute distance between two geometries.

Returns the shortest distance between the two geometries. The distance is expressed into the same unit as the coordinates of the geometries.

This method is the same as the C function OGR_G_Distance().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters:

  | poOtherGeom | the other geometry to compare against.

Returns:
  the distance between the geometries or -1 if an error occurs.

void OGRGeometry::dumpReadable | ( | FILE * | fp,
|  | const char * | pszPrefix = `NULL`,
|  | char ** | papszOptions = `NULL` |
| ) |  |  | const`[virtual]`

Dump geometry in well known text format to indicated output file.

A few options can be defined to change the default dump :

- DISPLAY_GEOMETRY=NO : to hide the dump of the geometry
- DISPLAY_GEOMETRY=WKT or YES (default) : dump the geometry as a WKT
- DISPLAY_GEOMETRY=SUMMARY : to get only a summary of the geometry

This method is the same as the C function OGR_G_DumpReadable().

Parameters:

  | fp | the text file to write the geometry to.
  | pszPrefix | the prefix to put on each line of output.
  | papszOptions | NULL terminated list of options (may be NULL)

References dumpReadable(), exportToWkt(), OGRPolygon::getExteriorRing(), getGeometryName(), OGRGeometryCollection::getGeometryRef(), getGeometryType(), OGRPolygon::getInteriorRing(), OGRGeometryCollection::getNumGeometries(), OGRPolygon::getNumInteriorRings(), OGRLineString::getNumPoints(), wkbGeometryCollection, wkbGeometryCollection25D, wkbLinearRing, wkbLineString, wkbLineString25D, wkbMultiLineString, wkbMultiLineString25D, wkbMultiPoint, wkbMultiPoint25D, wkbMultiPolygon, wkbMultiPolygon25D, wkbNone, wkbPoint, wkbPoint25D, wkbPolygon, wkbPolygon25D, and wkbUnknown.

Referenced by dumpReadable(), and OGRFeature::DumpReadable().

void OGRGeometry::empty | ( |  | ) | `[pure virtual]`

Clear geometry information. This restores the geometry to it's initial state after construction, and before assignment of actual geometry.

This method relates to the SFCOM IGeometry::Empty() method.

This method is the same as the C function OGR_G_Empty().

Implemented in OGRPoint, OGRLineString, OGRPolygon, and OGRGeometryCollection.

int OGRGeometry::Equals | ( | OGRGeometry * | poOtherGeom | ) | const`[pure virtual]`

Returns TRUE if two geometries are equivalent.

This method is the same as the C function OGR_G_Equals().

Returns:
  TRUE if equivalent or FALSE otherwise.

Implemented in OGRPoint, OGRLineString, OGRPolygon, and OGRGeometryCollection.

Referenced by OGRFeature::Equal(), and OGRGeometryCollection::Equals().

char * OGRGeometry::exportToGML | ( | const char *const * | papszOptions = `NULL` | ) | const`[virtual]`

Convert a geometry into GML format.

The GML geometry is expressed directly in terms of GML basic data types assuming the this is available in the gml namespace. The returned string should be freed with CPLFree() when no longer required.

The supported options in OGR 1.8.0 are :

- FORMAT=GML3. Otherwise it will default to GML 2.1.2 output.
- GML3_LINESTRING_ELEMENT=curve. (Only valid for FORMAT=GML3) To use gml:Curve element for linestrings. Otherwise gml:LineString will be used .
- GML3_LONGSRS=YES/NO. (Only valid for FORMAT=GML3) Default to YES. If YES, SRS with EPSG authority will be written with the "urn:ogc:def:crs:EPSG::" prefix. In the case, if the SRS is a geographic SRS without explicit AXIS order, but that the same SRS authority code imported with ImportFromEPSGA() should be treated as lat/long, then the function will take care of coordinate order swapping. If set to NO, SRS with EPSG authority will be written with the "EPSG:" prefix, even if they are in lat/long order.

This method is the same as the C function OGR_G_ExportToGMLEx().

Parameters:

  | papszOptions | NULL-terminated list of options.

Returns:
  A GML fragment or NULL in case of error.

char * OGRGeometry::exportToJson | ( |  | ) | const`[virtual]`

Convert a geometry into GeoJSON format.

The returned string should be freed with CPLFree() when no longer required.

This method is the same as the C function OGR_G_ExportToJson().

Returns:
  A GeoJSON fragment or NULL in case of error.

References OGR_G_ExportToJson().

char * OGRGeometry::exportToKML | ( |  | ) | const`[virtual]`

Convert a geometry into KML format.

The returned string should be freed with CPLFree() when no longer required.

This method is the same as the C function OGR_G_ExportToKML().

Returns:
  A KML fragment or NULL in case of error.

References OGR_G_ExportToKML().

OGRErr OGRGeometry::exportToWkb | ( | OGRwkbByteOrder | eByteOrder,
|  | unsigned char * | pabyData,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOgc` |
| ) |  |  | const`[pure virtual]`

Convert a geometry into well known binary format.

This method relates to the SFCOM IWks::ExportToWKB() method.

This method is the same as the C function OGR_G_ExportToWkb().

Parameters:

  | eByteOrder | One of wkbXDR or wkbNDR indicating MSB or LSB byte order respectively.
  | pabyData | a buffer into which the binary representation is written. This buffer must be at least OGRGeometry::WkbSize() byte in size.
  | eWkbVariant | What standard to use when exporting geometries with three dimensions (or more). The default wkbVariantOgc is the historical OGR variant. wkbVariantIso is the variant defined in ISO SQL/MM and adopted by OGC for SFSQL 1.2.

Returns:
  Currently OGRERR_NONE is always returned.

Implemented in OGRPoint, OGRLineString, OGRLinearRing, OGRPolygon, and OGRGeometryCollection.

Referenced by OGRGeometryCollection::exportToWkb().

OGRErr OGRGeometry::exportToWkt | ( | char ** | ppszDstText | ) | const`[pure virtual]`

Convert a geometry into well known text format.

This method relates to the SFCOM IWks::ExportToWKT() method.

This method is the same as the C function OGR_G_ExportToWkt().

Parameters:

  | ppszDstText | a text buffer is allocated by the program, and assigned to the passed pointer. After use, *ppszDstText should be freed with OGRFree().

Returns:
  Currently OGRERR_NONE is always returned.

Implemented in OGRPoint, OGRLineString, OGRPolygon, OGRGeometryCollection, OGRMultiPolygon, OGRMultiPoint, and OGRMultiLineString.

Referenced by dumpReadable(), OGRMultiPolygon::exportToWkt(), OGRMultiLineString::exportToWkt(), and OGRGeometryCollection::exportToWkt().

void OGRGeometry::flattenTo2D | ( |  | ) | `[pure virtual]`

Convert geometry to strictly 2D. In a sense this converts all Z coordinates to 0.0.

This method is the same as the C function OGR_G_FlattenTo2D().

Implemented in OGRPoint, OGRLineString, OGRPolygon, and OGRGeometryCollection.

OGRGeometry * OGRGeometry::getBoundary | ( |  | ) | const`[virtual]`

Compute boundary (deprecated).

Deprecated:

See also:
  Boundary()

References Boundary().

int OGRGeometry::getCoordinateDimension | ( |  | ) | const`[virtual]`

Get the dimension of the coordinates in this object.

This method corresponds to the SFCOM IGeometry::GetDimension() method.

This method is the same as the C function OGR_G_GetCoordinateDimension().

Returns:
  in practice this will return 2 or 3. It can also return 0 in the case of an empty point.

Referenced by OGRGeometryCollection::addGeometryDirectly(), OGRLineString::addPoint(), OGRPolygon::addRing(), OGRPolygon::addRingDirectly(), OGRLineString::clone(), OGRPolygon::exportToWkb(), OGRLineString::exportToWkb(), OGRPolygon::exportToWkt(), OGRMultiPoint::exportToWkt(), OGRLineString::exportToWkt(), OGRMultiPolygon::getGeometryType(), OGRMultiPoint::getGeometryType(), OGRMultiLineString::getGeometryType(), OGRGeometryCollection::getGeometryType(), OGRLineString::getPoint(), OGRLineString::getSubLine(), OGRLineString::segmentize(), OGRLineString::setNumPoints(), OGRLineString::setPoint(), OGRLineString::setPoints(), OGRLineString::Value(), OGRPolygon::WkbSize(), and OGRLineString::WkbSize().

int OGRGeometry::getDimension | ( |  | ) | const`[pure virtual]`

Get the dimension of this object.

This method corresponds to the SFCOM IGeometry::GetDimension() method. It indicates the dimension of the object, but does not indicate the dimension of the underlying space (as indicated by OGRGeometry::getCoordinateDimension()).

This method is the same as the C function OGR_G_GetDimension().

Returns:
  0 for points, 1 for lines and 2 for surfaces.

Implemented in OGRPoint, OGRLineString, OGRPolygon, OGRGeometryCollection, OGRMultiPolygon, OGRMultiPoint, and OGRMultiLineString.

Referenced by OGRGeometryCollection::getDimension(), OGRLayer::Identity(), OGRLayer::Intersection(), and OGRLayer::Union().

void OGRGeometry::getEnvelope | ( | OGREnvelope * | psEnvelope | ) | const`[pure virtual]`

Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure.

This method is the same as the C function OGR_G_GetEnvelope().

Parameters:

  | psEnvelope | the structure in which to place the results.

Implemented in OGRPoint, OGRLineString, OGRPolygon, and OGRGeometryCollection.

Referenced by OGRGeometryCollection::getEnvelope(), OGRLayer::Intersection(), Intersects(), OGRGeometryFactory::organizePolygons(), and OGRWarpedLayer::SetSpatialFilter().

void OGRGeometry::getEnvelope | ( | OGREnvelope3D * | psEnvelope | ) | const`[pure virtual]`

Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure.

This method is the same as the C function OGR_G_GetEnvelope3D().

Parameters:

  | psEnvelope | the structure in which to place the results.

Since:
  OGR 1.9.0

Implemented in OGRPoint, OGRLineString, OGRPolygon, and OGRGeometryCollection.

const char * OGRGeometry::getGeometryName | ( |  | ) | const`[pure virtual]`

Fetch WKT name for geometry type.

There is no SFCOM analog to this method.

This method is the same as the C function OGR_G_GetGeometryName().

Returns:
  name used for this geometry type in well known text format. The returned pointer is to a static internal string and should not be modified or freed.

Implemented in OGRPoint, OGRLineString, OGRLinearRing, OGRPolygon, OGRGeometryCollection, OGRMultiPolygon, OGRMultiPoint, and OGRMultiLineString.

Referenced by dumpReadable(), and OGRFeature::GetFieldAsString().

OGRwkbGeometryType OGRGeometry::getGeometryType | ( |  | ) | const`[pure virtual]`

Fetch geometry type.

Note that the geometry type may include the 2.5D flag. To get a 2D flattened version of the geometry type apply the wkbFlatten() macro to the return result.

This method is the same as the C function OGR_G_GetGeometryType().

Returns:
  the geometry type code.

Implemented in OGRPoint, OGRLineString, OGRPolygon, OGRGeometryCollection, OGRMultiPolygon, OGRMultiPoint, and OGRMultiLineString.

Referenced by OGRMultiPolygon::addGeometryDirectly(), OGRMultiPoint::addGeometryDirectly(), OGRMultiLineString::addGeometryDirectly(), Centroid(), dumpReadable(), OGRPolygon::Equals(), OGRPoint::Equals(), OGRLineString::Equals(), OGRGeometryCollection::Equals(), OGRGeometryFactory::forceToLineString(), OGRGeometryFactory::forceToMultiLineString(), OGRGeometryFactory::forceToMultiPoint(), OGRGeometryFactory::forceToMultiPolygon(), OGRGeometryFactory::forceToPolygon(), OGRGeometryCollection::get_Area(), OGRGeometryCollection::get_Length(), OGR_G_PointOnSurface(), OGRBuildPolygonFromEdges(), and Polygonize().

OGRSpatialReference * OGRGeometry::getSpatialReference | ( | void |  | ) | const`[inline]`

Returns spatial reference system for object.

This method relates to the SFCOM IGeometry::get_SpatialReference() method.

This method is the same as the C function OGR_G_GetSpatialReference().

Returns:
  a reference to the spatial reference object. The object may be shared with many geometry objects, and should not be modified.

Referenced by Boundary(), Buffer(), Centroid(), OGRPolygon::clone(), OGRPoint::clone(), OGRMultiPolygon::clone(), OGRMultiPoint::clone(), OGRMultiLineString::clone(), OGRLineString::clone(), OGRLinearRing::clone(), OGRGeometryCollection::clone(), ConvexHull(), Difference(), OGRGeometryFactory::forceToMultiLineString(), OGRGeometryFactory::forceToMultiPoint(), OGRGeometryFactory::forceToMultiPolygon(), OGRGeometryFactory::forceToPolygon(), OGRLineString::getSubLine(), Intersection(), OGR_G_PointOnSurface(), Polygonize(), Simplify(), SimplifyPreserveTopology(), SymDifference(), transformTo(), Union(), and UnionCascaded().

OGRErr OGRGeometry::importFromWkb | ( | unsigned char * | pabyData,
|  | int | nSize = `-1` |
| ) |  |  | `[pure virtual]`

Assign geometry from well known binary data.

The object must have already been instantiated as the correct derived type of geometry object to match the binaries type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKB() method.

This method is the same as the C function OGR_G_ImportFromWkb().

Parameters:

  | pabyData | the binary input data.
  | nSize | the size of pabyData in bytes, or zero if not known.

Returns:
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Implemented in OGRPoint, OGRLineString, OGRLinearRing, OGRPolygon, and OGRGeometryCollection.

Referenced by OGRGeometryFactory::createFromWkb().

OGRErr OGRGeometry::importFromWkt | ( | char ** | ppszInput | ) | `[pure virtual]`

Assign geometry from well known text data.

The object must have already been instantiated as the correct derived type of geometry object to match the text type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKT() method.

This method is the same as the C function OGR_G_ImportFromWkt().

Parameters:

  | ppszInput | pointer to a pointer to the source text. The pointer is updated to pointer after the consumed text.

Returns:
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Implemented in OGRPoint, OGRLineString, OGRPolygon, OGRGeometryCollection, OGRMultiPolygon, OGRMultiPoint, and OGRMultiLineString.

Referenced by OGRGeometryFactory::createFromWkt().

OGRGeometry * OGRGeometry::Intersection | ( | const OGRGeometry * | poOtherGeom | ) | const`[virtual]`

Compute intersection.

Generates a new geometry which is the region of intersection of the two geometries operated on. The Intersects() method can be used to test if two geometries intersect.

This method is the same as the C function OGR_G_Intersection().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters:

  | poOtherGeom | the other geometry intersected with "this" geometry.

Returns:
  a new geometry representing the intersection or NULL if there is no intersection or an error occurs.

References assignSpatialReference(), getSpatialReference(), and OGRSpatialReference::IsSame().

Referenced by OGRLayer::Clip(), OGRLayer::Identity(), OGRLayer::Intersection(), and OGRLayer::Union().

OGRBoolean OGRGeometry::Intersects | ( | OGRGeometry * | poOtherGeom | ) | const`[virtual]`

Do these features intersect?

Determines whether two geometries intersect. If GEOS is enabled, then this is done in rigerous fashion otherwise TRUE is returned if the envelopes (bounding boxes) of the two features overlap.

The poOtherGeom argument may be safely NULL, but in this case the method will always return TRUE. That is, a NULL geometry is treated as being everywhere.

This method is the same as the C function OGR_G_Intersects().

Parameters:

  | poOtherGeom | the other geometry to test against.

Returns:
  TRUE if the geometries intersect, otherwise FALSE.

References getEnvelope().

OGRBoolean OGRGeometry::IsEmpty | ( |  | ) | const`[pure virtual]`

Returns TRUE (non-zero) if the object has no points.

Normally this returns FALSE except between when an object is instantiated and points have been assigned.

This method relates to the SFCOM IGeometry::IsEmpty() method.

Returns:
  TRUE if object is empty, otherwise FALSE.

Implemented in OGRPoint, OGRLineString, OGRPolygon, and OGRGeometryCollection.

Referenced by OGRLayer::Clip(), OGRPolygon::Equals(), OGRPoint::Equals(), OGRLineString::Equals(), OGRGeometryCollection::Equals(), OGRLayer::Erase(), OGRLayer::Identity(), OGRLayer::Intersection(), OGRLayer::SymDifference(), OGRLayer::Union(), and OGRLayer::Update().

OGRBoolean OGRGeometry::IsRing | ( |  | ) | const`[virtual]`

Test if the geometry is a ring.

This method is the same as the C function OGR_G_IsRing().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always return FALSE.

Returns:
  TRUE if the geometry has no points, otherwise FALSE.

OGRBoolean OGRGeometry::IsSimple | ( |  | ) | const`[virtual]`

Test if the geometry is simple.

This method is the same as the C function OGR_G_IsSimple().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always return FALSE.

Returns:
  TRUE if the geometry has no points, otherwise FALSE.

OGRBoolean OGRGeometry::IsValid | ( |  | ) | const`[virtual]`

Test if the geometry is valid.

This method is the same as the C function OGR_G_IsValid().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always return FALSE.

Returns:
  TRUE if the geometry has no points, otherwise FALSE.

OGRBoolean OGRGeometry::Overlaps | ( | const OGRGeometry * | poOtherGeom | ) | const`[virtual]`

Test for overlap.

Tests if this geometry and the other passed into the method overlap, that is their intersection has a non-zero area.

This method is the same as the C function OGR_G_Overlaps().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters:

  | poOtherGeom | the geometry to compare to this geometry.

Returns:
  TRUE if they are overlapping, otherwise FALSE.

Referenced by OGRGeometryFactory::organizePolygons().

OGRGeometry * OGRGeometry::Polygonize | ( |  | ) | const`[virtual]`

Polygonizes a set of sparse edges.

A new geometry object is created and returned containing a collection of reassembled Polygons: NULL will be returned if the input collection doesn't corresponds to a MultiLinestring, or when reassembling Edges into Polygons is impossible due to topogical inconsistencies.

This method is the same as the C function OGR_G_Polygonize().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Returns:
  a newly allocated geometry now owned by the caller, or NULL on failure.

Since:
  OGR 1.9.0

References assignSpatialReference(), OGRGeometryCollection::getGeometryRef(), getGeometryType(), OGRGeometryCollection::getNumGeometries(), getSpatialReference(), wkbGeometryCollection, wkbLineString, and wkbMultiLineString.

void OGRGeometry::segmentize | ( | double | dfMaxLength | ) | `[virtual]`

Modify the geometry such it has no segment longer then the given distance.

Interpolated points will have Z and M values (if needed) set to 0. Distance computation is performed in 2d only

This function is the same as the C function OGR_G_Segmentize()

Parameters:

  | dfMaxLength | the maximum distance between 2 points after segmentization

Reimplemented in OGRLineString, OGRPolygon, and OGRGeometryCollection.

void OGRGeometry::setCoordinateDimension | ( | int | nNewDimension | ) | `[virtual]`

Set the coordinate dimension.

This method sets the explicit coordinate dimension. Setting the coordinate dimension of a geometry to 2 should zero out any existing Z values. Setting the dimension of a geometry collection will not necessarily affect the children geometries.

Parameters:

  | nNewDimension | New coordinate dimension value, either 2 or 3.

Reimplemented in OGRPoint, OGRLineString, OGRPolygon, and OGRGeometryCollection.

Referenced by OGRGeometryCollection::setCoordinateDimension().

OGRGeometry * OGRGeometry::Simplify | ( | double | dTolerance | ) | const`[virtual]`

Simplify the geometry.

This function is the same as the C function OGR_G_Simplify().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters:

  | dTolerance | the distance tolerance for the simplification.

Returns:
  the simplified geometry or NULL if an error occurs.

Since:
  OGR 1.8.0

References assignSpatialReference(), and getSpatialReference().

OGRGeometry * OGRGeometry::SimplifyPreserveTopology | ( | double | dTolerance | ) | const

Simplify the geometry while preserving topology.

This function is the same as the C function OGR_G_SimplifyPreserveTopology().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters:

  | dTolerance | the distance tolerance for the simplification.

Returns:
  the simplified geometry or NULL if an error occurs.

Since:
  OGR 1.9.0

References assignSpatialReference(), and getSpatialReference().

void OGRGeometry::swapXY | ( |  | ) | `[virtual]`

Swap x and y coordinates.

Since:
  OGR 1.8.0

Reimplemented in OGRPoint, OGRLineString, OGRPolygon, and OGRGeometryCollection.

OGRGeometry * OGRGeometry::SymDifference | ( | const OGRGeometry * | poOtherGeom | ) | const`[virtual]`

Compute symmetric difference.

Generates a new geometry which is the symmetric difference of this geometry and the second geometry passed into the method.

This method is the same as the C function OGR_G_SymDifference().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters:

  | poOtherGeom | the other geometry.

Returns:
  a new geometry representing the symmetric difference or NULL if the difference is empty or an error occurs.

Since:
  OGR 1.8.0

References assignSpatialReference(), getSpatialReference(), and OGRSpatialReference::IsSame().

Referenced by SymmetricDifference().

OGRGeometry * OGRGeometry::SymmetricDifference | ( | const OGRGeometry * | poOtherGeom | ) | const`[virtual]`

Compute symmetric difference (deprecated).

Deprecated:

See also:
  OGRGeometry::SymDifference()

References SymDifference().

OGRBoolean OGRGeometry::Touches | ( | const OGRGeometry * | poOtherGeom | ) | const`[virtual]`

Test for touching.

Tests if this geometry and the other passed into the method are touching.

This method is the same as the C function OGR_G_Touches().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters:

  | poOtherGeom | the geometry to compare to this geometry.

Returns:
  TRUE if they are touching, otherwise FALSE.

OGRErr OGRGeometry::transform | ( | OGRCoordinateTransformation * | poCT | ) | `[pure virtual]`

Apply arbitrary coordinate transformation to geometry.

This method will transform the coordinates of a geometry from their current spatial reference system to a new target spatial reference system. Normally this means reprojecting the vectors, but it could include datum shifts, and changes of units.

Note that this method does not require that the geometry already have a spatial reference system. It will be assumed that they can be treated as having the source spatial reference system of the OGRCoordinateTransformation object, and the actual SRS of the geometry will be ignored. On successful completion the output OGRSpatialReference of the OGRCoordinateTransformation will be assigned to the geometry.

This method is the same as the C function OGR_G_Transform().

Parameters:

  | poCT | the transformation to apply.

Returns:
  OGRERR_NONE on success or an error code.

Implemented in OGRPoint, OGRLineString, OGRPolygon, and OGRGeometryCollection.

Referenced by OGRGeometryCollection::transform(), and transformTo().

OGRErr OGRGeometry::transformTo | ( | OGRSpatialReference * | poSR | ) |

Transform geometry to new spatial reference system.

This method will transform the coordinates of a geometry from their current spatial reference system to a new target spatial reference system. Normally this means reprojecting the vectors, but it could include datum shifts, and changes of units.

This method will only work if the geometry already has an assigned spatial reference system, and if it is transformable to the target coordinate system.

Because this method requires internal creation and initialization of an OGRCoordinateTransformation object it is significantly more expensive to use this method to transform many geometries than it is to create the OGRCoordinateTransformation in advance, and call transform() with that transformation. This method exists primarily for convenience when only transforming a single geometry.

This method is the same as the C function OGR_G_TransformTo().

Parameters:

  | poSR | spatial reference system to transform to.

Returns:
  OGRERR_NONE on success, or an error code.

References getSpatialReference(), OGRCreateCoordinateTransformation(), and transform().

OGRGeometry * OGRGeometry::Union | ( | const OGRGeometry * | poOtherGeom | ) | const`[virtual]`

Compute union.

Generates a new geometry which is the region of union of the two geometries operated on.

This method is the same as the C function OGR_G_Union().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters:

  | poOtherGeom | the other geometry unioned with "this" geometry.

Returns:
  a new geometry representing the union or NULL if an error occurs.

References assignSpatialReference(), getSpatialReference(), and OGRSpatialReference::IsSame().

Referenced by OGRLayer::Clip(), and OGRLayer::Erase().

OGRGeometry * OGRGeometry::UnionCascaded | ( |  | ) | const`[virtual]`

Compute union using cascading.

This method is the same as the C function OGR_G_UnionCascaded().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Returns:
  a new geometry representing the union or NULL if an error occurs.

Since:
  OGR 1.8.0

References assignSpatialReference(), and getSpatialReference().

OGRBoolean OGRGeometry::Within | ( | const OGRGeometry * | poOtherGeom | ) | const`[virtual]`

Test for containment.

Tests if actual geometry object is within the passed geometry.

This method is the same as the C function OGR_G_Within().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters:

  | poOtherGeom | the geometry to compare to this geometry.

Returns:
  TRUE if poOtherGeom is within this geometry, otherwise FALSE.

int OGRGeometry::WkbSize | ( |  | ) | const`[pure virtual]`

Returns size of related binary representation.

This method returns the exact number of bytes required to hold the well known binary representation of this geometry object. Its computation may be slightly expensive for complex geometries.

This method relates to the SFCOM IWks::WkbSize() method.

This method is the same as the C function OGR_G_WkbSize().

Returns:
  size of binary representation in bytes.

Implemented in OGRPoint, OGRLineString, OGRLinearRing, OGRPolygon, and OGRGeometryCollection.

Referenced by OGRGeometryCollection::exportToWkb(), and OGRGeometryCollection::WkbSize().

The documentation for this class was generated from the following files:

- ogr_geometry.h
- ogrgeometry.cpp

Generated for GDAL by 1.7.1.